/**************************************************************** 
 * Description: 
 * Author: Alex Li
 * Date: 2024-01-29 00:52:20
 * LastEditTime: 2024-01-30 07:19:37
****************************************************************/
#include <bits/stdc++.h>
using namespace std;

int n, op, x; // 定义操作次数n，操作类型op和操作数x
priority_queue <int, vector <int>, greater <int> > q; // 定义一个小根堆q，详见下方注释


int main() {
    cin >> n; // 读入操作次数
    while(n--) { // 对每个操作进行循环
        cin >> op; // 读入操作类型
        if(op == 1) { // 如果操作类型为1
            cin >> x; // 读入要添加的数
            q.push(x); // 将数添加到小根堆中
        } else if(op == 2) // 如果操作类型为2
            cout << q.top() << endl; // 输出堆顶元素（数列中的最小数）
        else // 如果操作类型为3
            q.pop(); // 弹出堆顶元素（删除数列中的最小数）
    }
    return 0;
}

/*
priority_queue <int, vector <int>, greater <int> > q;

priority_queue<int, vector<int>, greater<int>> 是一个模板类的实例化。这个模板类有三个模板参数：

第一个参数 int 指定了队列中元素的类型。在这个例子中，队列将存储整数。
第二个参数 vector<int> 指定了内部容器的类型。priority_queue 需要一个顺序容器来存储其元素。
         默认情况下，priority_queue 使用 vector 作为其内部容器，但这可以被其他容器替换，只要它们提供随机访问迭代器（比如 deque）。
         这里使用 vector<int> 表明使用 vector 来存储 int 类型的元素。
第三个参数 greater<int> 指定了用于比较元素的函数对象。默认情况下，priority_queue 使用 less<T>，这会导致最大的元素总是位于队列的顶部（形成大根堆）。
         但在这里，通过指定 greater<int>，队列的行为被修改为使得最小的元素总是位于顶部，从而创建了一个小根堆。

*/